diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/identify_tools.cpp libkdcraw/libkdcraw/libraw/src/metadata/identify_tools.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/identify_tools.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/identify_tools.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,140 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw uses code from dcraw.c -- Dave Coffin's raw photo decoder,
+ dcraw.c is copyright 1997-2018 by Dave Coffin, dcoffin a cybercom o net.
+ LibRaw do not use RESTRICTED code from dcraw.c
+
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+short LibRaw::guess_byte_order(int words)
+{
+  uchar test[4][2];
+  int t = 2, msb;
+  double diff, sum[2] = {0, 0};
+
+  fread(test[0], 2, 2, ifp);
+  for (words -= 2; words--;)
+  {
+    fread(test[t], 2, 1, ifp);
+    for (msb = 0; msb < 2; msb++)
+    {
+      diff = (test[t ^ 2][msb] << 8 | test[t ^ 2][!msb]) -
+             (test[t][msb] << 8 | test[t][!msb]);
+      sum[msb] += diff * diff;
+    }
+    t = (t + 1) & 3;
+  }
+  return sum[0] < sum[1] ? 0x4d4d : 0x4949;
+}
+
+float LibRaw::find_green(int bps, int bite, int off0, int off1)
+{
+  UINT64 bitbuf = 0;
+  int vbits, col, i, c;
+  ushort img[2][2064];
+  double sum[] = {0, 0};
+  if (width > 2064)
+    return 0.f; // too wide
+
+  FORC(2)
+  {
+    fseek(ifp, c ? off1 : off0, SEEK_SET);
+    for (vbits = col = 0; col < width; col++)
+    {
+      for (vbits -= bps; vbits < 0; vbits += bite)
+      {
+        bitbuf <<= bite;
+        for (i = 0; i < bite; i += 8)
+          bitbuf |= (unsigned)(fgetc(ifp) << i);
+      }
+      img[c][col] = bitbuf << (64 - bps - vbits) >> (64 - bps);
+    }
+  }
+  FORC(width - 1)
+  {
+    sum[c & 1] += ABS(img[0][c] - img[1][c + 1]);
+    sum[~c & 1] += ABS(img[1][c] - img[0][c + 1]);
+  }
+  if (sum[0] >= 1.0 && sum[1] >= 1.0)
+    return 100 * log(sum[0] / sum[1]);
+  else
+    return 0.f;
+}
+
+void LibRaw::trimSpaces(char *s)
+{
+  char *p = s;
+  int l = strlen(p);
+  if (!l)
+    return;
+  while (isspace(p[l - 1]))
+    p[--l] = 0; /* trim trailing spaces */
+  while (*p && isspace(*p))
+    ++p, --l;   /* trim leading spaces */
+  memmove(s, p, l + 1);
+}
+
+void LibRaw::remove_trailing_spaces(char *string, size_t len)
+{
+  if (len < 1)
+    return; // not needed, b/c sizeof of make/model is 64
+  string[len - 1] = 0;
+  if (len < 3)
+    return; // also not needed
+  len = strnlen(string, len - 1);
+  for (int i = len - 1; i >= 0; i--)
+  {
+    if (isspace((unsigned char)string[i]))
+      string[i] = 0;
+    else
+      break;
+  }
+}
+
+void LibRaw::remove_caseSubstr(char *string, char *subStr) // replace a substring with an equal length of spaces
+{
+  char *found;
+  while ((found = strcasestr(string,subStr))) {
+    if (!found) return;
+    int fill_len = strlen(subStr);
+    int p = found - string;
+    for (int i=p; i<p+fill_len; i++) {
+      string[i] = 32;
+    }
+  }
+  trimSpaces (string);
+}
+
+void LibRaw::removeExcessiveSpaces(char *string) // replace repeating spaces with one space
+{
+	int orig_len = strlen(string);
+	int i = 0;   // counter for resulting string
+	int j = -1;
+	bool prev_char_is_space = false;
+	while (++j < orig_len && string[j] == ' ');
+	while (j < orig_len)  {
+		if (string[j] != ' ')  {
+				string[i++] = string[j++];
+				prev_char_is_space = false;
+		} else if (string[j++] == ' ') {
+			if (!prev_char_is_space) {
+				string[i++] = ' ';
+				prev_char_is_space = true;
+			}
+		}
+	}
+	if (string[i-1] == ' ')
+    string[i-1] = 0;
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/kodak.cpp libkdcraw/libkdcraw/libraw/src/metadata/kodak.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/kodak.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/kodak.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,363 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::Kodak_KDC_WBtags(int wb, int wbi)
+{
+  int c;
+  FORC3 icWBC[wb][c] = get4();
+  icWBC[wb][3] = icWBC[wb][1];
+  if (wbi == wb)
+    FORC4 cam_mul[c] = icWBC[wb][c];
+  return;
+}
+
+void LibRaw::Kodak_DCR_WBtags(int wb, unsigned type, int wbi)
+{
+  float mul[3] = {1.0f, 1.0f, 1.0f}, num, mul2;
+  int c;
+  FORC3 mul[c] = (num = getreal(type)) <= 0.001f ? 1.0f : num;
+  icWBC[wb][1] = icWBC[wb][3] = mul[1];
+  mul2 = mul[1] * mul[1];
+  icWBC[wb][0] = mul2 / mul[0];
+  icWBC[wb][2] = mul2 / mul[2];
+  if (wbi == wb)
+    FORC4 cam_mul[c] = icWBC[wb][c];
+  return;
+}
+
+short LibRaw::KodakIllumMatrix(unsigned type, float *romm_camIllum)
+{
+  int c, j, romm_camTemp[9], romm_camScale[3];
+  if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SRATIONAL))
+  {
+    for (j = 0; j < 9; j++)
+      ((float *)romm_camIllum)[j] = getreal(type);
+    return 1;
+  }
+  else if (tagtypeIs(LIBRAW_EXIFTAG_TYPE_SLONG))
+  {
+    FORC3
+    {
+      romm_camScale[c] = 0;
+      for (j = 0; j < 3; j++)
+      {
+        romm_camTemp[c * 3 + j] = get4();
+        romm_camScale[c] += romm_camTemp[c * 3 + j];
+      }
+    }
+    if ((romm_camScale[0] > 0x1fff) && (romm_camScale[1] > 0x1fff) &&
+        (romm_camScale[2] > 0x1fff))
+    {
+      FORC3 for (j = 0; j < 3; j++)((float *)romm_camIllum)[c * 3 + j] =
+          ((float)romm_camTemp[c * 3 + j]) / ((float)romm_camScale[c]);
+      return 1;
+    }
+  }
+  return 0;
+}
+
+/* Thanks to Alexey Danilchenko for wb as-shot parsing code */
+void LibRaw::parse_kodak_ifd(int base)
+{
+  unsigned entries, tag, type, len, save;
+  int c, wbi = -1;
+
+  static const int wbtag_kdc[] = {
+      LIBRAW_WBI_Auto,        // 64037 / 0xfa25
+      LIBRAW_WBI_Fluorescent, // 64040 / 0xfa28
+      LIBRAW_WBI_Tungsten,    // 64039 / 0xfa27
+      LIBRAW_WBI_Daylight,    // 64041 / 0xfa29
+      -1,
+      -1,
+      LIBRAW_WBI_Shade // 64042 / 0xfa2a
+  };
+
+  static const int wbtag_dcr[] = {
+      LIBRAW_WBI_Daylight,    // 2120 / 0x0848
+      LIBRAW_WBI_Tungsten,    // 2121 / 0x0849
+      LIBRAW_WBI_Fluorescent, // 2122 / 0x084a
+      LIBRAW_WBI_Flash,       // 2123 / 0x084b
+      LIBRAW_WBI_Custom,      // 2124 / 0x084c
+      LIBRAW_WBI_Auto         // 2125 / 0x084d
+  };
+
+  //  int a_blck = 0;
+
+  entries = get2();
+  if (entries > 1024)
+    return;
+  INT64 fsize = ifp->size();
+  while (entries--)
+  {
+    tiff_get(base, &tag, &type, &len, &save);
+    INT64 savepos = ftell(ifp);
+    if (len > 8 && len + savepos > 2 * fsize)
+    {
+      fseek(ifp, save, SEEK_SET); // Recover tiff-read position!!
+      continue;
+    }
+    if (callbacks.exif_cb)
+    {
+      callbacks.exif_cb(callbacks.exifparser_data, tag | 0x20000, type, len,
+                        order, ifp, base);
+      fseek(ifp, savepos, SEEK_SET);
+    }
+    if (tag == 0x03eb) // 1003
+      imgdata.sizes.raw_inset_crop.cleft = get2();
+    else if (tag == 0x03ec) // 1004
+      imgdata.sizes.raw_inset_crop.ctop = get2();
+    else if (tag == 0x03ed) // 1005
+      imgdata.sizes.raw_inset_crop.cwidth = get2();
+    else if (tag == 0x03ee) // 1006
+      imgdata.sizes.raw_inset_crop.cheight = get2();
+    else if (tag == 0x03ef) // 1007
+    {
+      if (!strcmp(model, "EOS D2000C"))
+        black = get2();
+      else
+        imKodak.BlackLevelTop = get2();
+    }
+    else if (tag == 0x03f0) // 1008
+    {
+      if (!strcmp(model, "EOS D2000C"))
+      {
+        if (black) // already set by tag 1007 (0x03ef)
+          black = (black + get2()) / 2;
+        else
+          black = get2();
+      }
+      else
+        imKodak.BlackLevelBottom = get2();
+    }
+
+    else if (tag == 0x03f1)
+    { // 1009 Kodak TextualInfo
+      if (len > 0)
+      {
+        char kti[1024];
+        char *pkti;
+        int nsym = MIN(len, 1023);
+        fread(kti, 1, nsym, ifp);
+        kti[nsym] = 0;
+#ifdef LIBRAW_WIN32_CALLS
+        pkti = strtok(kti, "\x0a");
+#else
+        char *last = 0;
+        pkti = strtok_r(kti, "\x0a", &last);
+#endif
+        while (pkti != NULL)
+        {
+          c = 12;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Camera body:", c)))
+          {
+            while ((pkti[c] == ' ') && (c < (int)strlen(pkti)))
+            {
+              c++;
+            }
+            strcpy(ilm.body, pkti + c);
+          }
+          c = 5;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Lens:", c)))
+          {
+            ilm.CurFocal = atoi(pkti + c);
+          }
+          c = 9;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Aperture:", c)))
+          {
+            while (((pkti[c] == ' ') || (pkti[c] == 'f')) && (c < (int)strlen(pkti)))
+            {
+              c++;
+            }
+            ilm.CurAp = atof(pkti + c);
+          }
+          c = 10;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "ISO Speed:", c)))
+          {
+            iso_speed = atoi(pkti + c);
+          }
+          c = 13;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Focal Length:", c)))
+          {
+            ilm.CurFocal = atoi(pkti + c);
+          }
+          c = 13;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Max Aperture:", c)))
+          {
+            while (((pkti[c] == ' ') || (pkti[c] == 'f')) && (c < (int)strlen(pkti)))
+            {
+              c++;
+            }
+            ilm.MaxAp4CurFocal = atof(pkti + c);
+          }
+          c = 13;
+          if (((int)strlen(pkti) > c) && (!strncasecmp(pkti, "Min Aperture:", c)))
+          {
+            while (((pkti[c] == ' ') || (pkti[c] == 'f')) && (c < (int)strlen(pkti)))
+            {
+              c++;
+            }
+            ilm.MinAp4CurFocal = atof(pkti + c);
+          }
+#ifdef LIBRAW_WIN32_CALLS
+          pkti = strtok(NULL, "\x0a");
+#else
+          pkti = strtok_r(NULL, "\x0a", &last);
+#endif
+        }
+      }
+    }
+
+    else if (tag == 0x03f3) // 1011
+      imCommon.FlashEC = getreal(type);
+
+    else if (tag == 0x03fc) // 1020
+    {
+      wbi = getint(type);
+      if ((wbi >= 0) && (wbi < 6) && (wbi != -2))
+        wbi = wbtag_dcr[wbi];
+    }
+    else if (tag == 0x03fd && len == 72) // 1021
+    {                                    /* WB set in software */
+      fseek(ifp, 40, SEEK_CUR);
+      FORC3 cam_mul[c] = 2048.0 / fMAX(1.0f, get2());
+      wbi = -2;
+    }
+
+    else if ((tag == 0x0406) && (len == 1)) // 1030
+      imCommon.CameraTemperature = getreal(type);
+    else if ((tag == 0x0413) && (len == 1)) // 1043
+      imCommon.SensorTemperature = getreal(type);
+    else if (tag == 0x0848) // 2120
+      Kodak_DCR_WBtags(LIBRAW_WBI_Daylight, type, wbi);
+    else if (tag == 0x0849) // 2121
+      Kodak_DCR_WBtags(LIBRAW_WBI_Tungsten, type, wbi);
+    else if (tag == 0x084a) // 2122
+      Kodak_DCR_WBtags(LIBRAW_WBI_Fluorescent, type, wbi);
+    else if (tag == 0x084b) // 2123
+      Kodak_DCR_WBtags(LIBRAW_WBI_Flash, type, wbi);
+    else if (tag == 0x084c) // 2124
+      Kodak_DCR_WBtags(LIBRAW_WBI_Custom, type, wbi);
+    else if (tag == 0x084d) // 2125
+    {
+      if (wbi == -1)
+        wbi = LIBRAW_WBI_Auto;
+      Kodak_DCR_WBtags(LIBRAW_WBI_Auto, type, wbi);
+    }
+    else if (tag == 0x089f) // 2207
+      imKodak.ISOCalibrationGain = getreal(type);
+    else if (tag == 0x0903) // 2307
+      imKodak.AnalogISO = iso_speed = getreal(type);
+    else if (tag == 0x090d) // 2317
+      linear_table(len);
+    else if (tag == 0x09ce) // 2510
+      stmread(imgdata.shootinginfo.InternalBodySerial, len, ifp);
+    else if (tag == 0x0e92) // 3730
+    {
+      imKodak.val018percent = get2();
+      imgdata.color.linear_max[0] = imgdata.color.linear_max[1] =
+          imgdata.color.linear_max[2] = imgdata.color.linear_max[3] =
+              (int)(((float)imKodak.val018percent) / 18.0f * 170.0f);
+    }
+    else if (tag == 0x0e93) // 3731
+      imgdata.color.linear_max[0] = imgdata.color.linear_max[1] =
+          imgdata.color.linear_max[2] = imgdata.color.linear_max[3] =
+              imKodak.val170percent = get2();
+    else if (tag == 0x0e94) // 3732
+      imKodak.val100percent = get2();
+    /*
+        else if (tag == 0x1784)    // 6020
+          iso_speed = getint(type);
+    */
+    else if (tag == 0xfa00) // 64000
+      stmread(imgdata.shootinginfo.BodySerial, len, ifp);
+    else if (tag == 0xfa0d) // 64013
+    {
+      wbi = fgetc(ifp);
+      if ((wbi >= 0) && (wbi < 7))
+        wbi = wbtag_kdc[wbi];
+    }
+    else if (tag == 0xfa13) // 64019
+      width = getint(type);
+    else if (tag == 0xfa14) // 64020
+      height = (getint(type) + 1) & -2;
+    /*
+          height = getint(type);
+
+        else if (tag == 0xfa16)  // 64022
+          raw_width = get2();
+        else if (tag == 0xfa17)  // 64023
+          raw_height = get2();
+    */
+    else if (tag == 0xfa18) // 64024
+    {
+      imKodak.offset_left = getint(LIBRAW_EXIFTAG_TYPE_SSHORT);
+      if (type != LIBRAW_EXIFTAG_TYPE_SSHORT)
+        imKodak.offset_left += 1;
+    }
+    else if (tag == 0xfa19) // 64025
+    {
+      imKodak.offset_top = getint(LIBRAW_EXIFTAG_TYPE_SSHORT);
+      if (type != LIBRAW_EXIFTAG_TYPE_SSHORT)
+        imKodak.offset_top += 1;
+    }
+
+    else if (tag == 0xfa25) // 64037
+      Kodak_KDC_WBtags(LIBRAW_WBI_Auto, wbi);
+    else if (tag == 0xfa27) // 64039
+      Kodak_KDC_WBtags(LIBRAW_WBI_Tungsten, wbi);
+    else if (tag == 0xfa28) // 64040
+      Kodak_KDC_WBtags(LIBRAW_WBI_Fluorescent, wbi);
+    else if (tag == 0xfa29) // 64041
+      Kodak_KDC_WBtags(LIBRAW_WBI_Daylight, wbi);
+    else if (tag == 0xfa2a) // 64042
+      Kodak_KDC_WBtags(LIBRAW_WBI_Shade, wbi);
+
+    else if (tag == 0xfa31) // 64049
+      imgdata.sizes.raw_inset_crop.cwidth = get2();
+    else if (tag == 0xfa32) // 64050
+      imgdata.sizes.raw_inset_crop.cheight = get2();
+    else if (tag == 0xfa3e) // 64062
+      imgdata.sizes.raw_inset_crop.cleft = get2();
+    else if (tag == 0xfa3f) // 64063
+      imgdata.sizes.raw_inset_crop.ctop = get2();
+
+    else if (((tag == 0x07e4) || (tag == 0xfb01)) &&
+             (len == 9)) // 2020 or 64257
+    {
+      if (KodakIllumMatrix(type, (float *)imKodak.romm_camDaylight))
+      {
+        romm_coeff(imKodak.romm_camDaylight);
+      }
+    }
+    else if (((tag == 0x07e5) || (tag == 0xfb02)) &&
+             (len == 9)) // 2021 or 64258
+      KodakIllumMatrix(type, (float *)imKodak.romm_camTungsten);
+    else if (((tag == 0x07e6) || (tag == 0xfb03)) &&
+             (len == 9)) // 2022 or 64259
+      KodakIllumMatrix(type, (float *)imKodak.romm_camFluorescent);
+    else if (((tag == 0x07e7) || (tag == 0xfb04)) &&
+             (len == 9)) // 2023 or 64260
+      KodakIllumMatrix(type, (float *)imKodak.romm_camFlash);
+    else if (((tag == 0x07e8) || (tag == 0xfb05)) &&
+             (len == 9)) // 2024 or 64261
+      KodakIllumMatrix(type, (float *)imKodak.romm_camCustom);
+    else if (((tag == 0x07e9) || (tag == 0xfb06)) &&
+             (len == 9)) // 2025 or 64262
+      KodakIllumMatrix(type, (float *)imKodak.romm_camAuto);
+
+    fseek(ifp, save, SEEK_SET);
+  }
+}
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/src/metadata/leica.cpp libkdcraw/libkdcraw/libraw/src/metadata/leica.cpp
--- libkdcraw-wrk/libkdcraw/libraw/src/metadata/leica.cpp	1970-01-01 03:00:00.000000000 +0300
+++ libkdcraw/libkdcraw/libraw/src/metadata/leica.cpp	2022-11-07 07:46:31.734795008 +0300
@@ -0,0 +1,357 @@
+/* -*- C++ -*-
+ * Copyright 2019-2020 LibRaw LLC (info@libraw.org)
+ *
+ LibRaw is free software; you can redistribute it and/or modify
+ it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
+ */
+
+#include "../../internal/dcraw_defs.h"
+
+void LibRaw::setLeicaBodyFeatures(int LeicaMakernoteSignature)
+{
+  if (LeicaMakernoteSignature == -3)
+  { // M8
+    ilm.CameraFormat = LIBRAW_FORMAT_APSH;
+    ilm.CameraMount = LIBRAW_MOUNT_Leica_M;
+  }
+  else if (LeicaMakernoteSignature == -2)
+  { // DMR
+    ilm.CameraFormat = LIBRAW_FORMAT_Leica_DMR;
+    if ((model[0] == 'R') || (model[6] == 'R'))
+      ilm.CameraMount = LIBRAW_MOUNT_Leica_R;
+  }
+  else if (LeicaMakernoteSignature == 0)
+  { // DIGILUX 2
+    ilm.CameraMount = ilm.LensMount = LIBRAW_MOUNT_FixedLens;
+    ilm.FocalType = LIBRAW_FT_ZOOM_LENS;
+  }
+  else if ((LeicaMakernoteSignature == 0x0100) || // X1
+           (LeicaMakernoteSignature == 0x0500) || // X2, X-E (Typ 102)
+           (LeicaMakernoteSignature == 0x0700) || // X (Typ 113)
+           (LeicaMakernoteSignature == 0x1000))
+  { // X-U (Typ 113)
+    ilm.CameraFormat = ilm.LensFormat = LIBRAW_FORMAT_APSC;
+    ilm.CameraMount = ilm.LensMount = LIBRAW_MOUNT_FixedLens;
+    ilm.FocalType = LIBRAW_FT_PRIME_LENS;
+  }
+  else if (LeicaMakernoteSignature == 0x0400)
+  { // X VARIO (Typ 107)
+    ilm.CameraFormat = ilm.LensFormat = LIBRAW_FORMAT_APSC;
+    ilm.CameraMount = ilm.LensMount = LIBRAW_MOUNT_FixedLens;
+    ilm.FocalType = LIBRAW_FT_ZOOM_LENS;
+  }
+  else if ((LeicaMakernoteSignature == 0x0200) || // M10, M10-D, S (Typ 007)
+           (LeicaMakernoteSignature ==
+            0x02ff) || // M (Typ 240), M (Typ 262), M-D (Typ 262), M Monochrom
+                       // (Typ 246), S (Typ 006), S-E (Typ 006), S2, S3
+           (LeicaMakernoteSignature == 0x0300))
+  { // M9, M9 Monochrom, M Monochrom, M-E
+    if ((model[0] == 'M') || (model[6] == 'M'))
+    {
+      ilm.CameraFormat = LIBRAW_FORMAT_FF;
+      ilm.CameraMount = LIBRAW_MOUNT_Leica_M;
+    }
+    else if ((model[0] == 'S') || (model[6] == 'S'))
+    {
+      ilm.CameraFormat = LIBRAW_FORMAT_LeicaS;
+      ilm.CameraMount = LIBRAW_MOUNT_Leica_S;
+    }
+  }
+  else if ((LeicaMakernoteSignature == 0x0600) || // T (Typ 701), TL
+           (LeicaMakernoteSignature == 0x0900) || // SL2, SL (Typ 601), CL, Q2
+           (LeicaMakernoteSignature == 0x1a00))   // TL2
+  {
+    if ((model[0] == 'S') || (model[6] == 'S'))
+    {
+      ilm.CameraFormat = LIBRAW_FORMAT_FF;
+      ilm.CameraMount = LIBRAW_MOUNT_LPS_L;
+    }
+    else if ((model[0] == 'T') || (model[6] == 'T') || (model[0] == 'C') ||
+             (model[6] == 'C'))
+    {
+      ilm.CameraFormat = LIBRAW_FORMAT_APSC;
+      ilm.CameraMount = LIBRAW_MOUNT_LPS_L;
+    }
+    else if (((model[0] == 'Q') || (model[6] == 'Q')) &&
+             ((model[1] == '2') || (model[7] == '2')))
+    {
+      ilm.CameraFormat = ilm.LensFormat = LIBRAW_FORMAT_FF;
+      ilm.CameraMount = ilm.LensMount = LIBRAW_MOUNT_FixedLens;
+      ilm.FocalType = LIBRAW_FT_PRIME_LENS;
+    }
+  }
+  else if (LeicaMakernoteSignature == 0x0800)
+  { // Q (Typ 116)
+    ilm.CameraFormat = ilm.LensFormat = LIBRAW_FORMAT_FF;
+    ilm.CameraMount = ilm.LensMount = LIBRAW_MOUNT_FixedLens;
+    ilm.FocalType = LIBRAW_FT_PRIME_LENS;
+  }
+}
+
+void LibRaw::parseLeicaLensID()
+{
+  ilm.LensID = get4();
+  if (ilm.LensID)
+  {
+    ilm.LensID = ((ilm.LensID >> 2) << 8) | (ilm.LensID & 0x3);
+    if ((ilm.LensID > 0x00ff) && (ilm.LensID < 0x3b00))
+    {
+      ilm.LensMount = ilm.CameraMount;
+      ilm.LensFormat = LIBRAW_FORMAT_FF;
+    }
+  }
+}
+
+int LibRaw::parseLeicaLensName(unsigned len)
+{
+#define plln ilm.Lens
+  if (!len)
+  {
+    strcpy(plln, "N/A");
+    return 0;
+  }
+  stmread(plln, len, ifp);
+  if ((plln[0] == ' ') || !strncasecmp(plln, "not ", 4) ||
+      !strncmp(plln, "---", 3) || !strncmp(plln, "***", 3))
+  {
+    strcpy(plln, "N/A");
+    return 0;
+  }
+  else
+    return 1;
+#undef plln
+}
+
+int LibRaw::parseLeicaInternalBodySerial(unsigned len)
+{
+#define plibs imgdata.shootinginfo.InternalBodySerial
+  if (!len)
+  {
+    strcpy(plibs, "N/A");
+    return 0;
+  }
+  stmread(plibs, len, ifp);
+  if (!strncmp(plibs, "000000000000", 12))
+  {
+    plibs[0] = '0';
+    plibs[1] = '\0';
+    return 1;
+  }
+
+  if (strnlen(plibs, len) == 13)
+  {
+    for (int i = 3; i < 13; i++)
+    {
+      if (!isdigit(plibs[i]))
+        goto non_std;
+    }
+    memcpy(plibs + 15, plibs + 9, 4);
+    memcpy(plibs + 12, plibs + 7, 2);
+    memcpy(plibs + 9, plibs + 5, 2);
+    memcpy(plibs + 6, plibs + 3, 2);
+    plibs[3] = plibs[14] = ' ';
+    plibs[8] = plibs[11] = '/';
+    if (((short)(plibs[3] - '0') * 10 + (short)(plibs[4] - '0')) < 70)
+    {
+      memcpy(plibs + 4, "20", 2);
+    }
+    else
+    {
+      memcpy(plibs + 4, "19", 2);
+    }
+    return 2;
+  }
+non_std:
+#undef plibs
+  return 1;
+}
+
+void LibRaw::parseLeicaMakernote(int base, int uptag, unsigned MakernoteTagType)
+{
+  int c;
+  uchar ci, cj;
+  unsigned entries, tag, type, len, save;
+  short morder, sorder = order;
+  char buf[10];
+  int LeicaMakernoteSignature = -1;
+  INT64 fsize = ifp->size();
+  fread(buf, 1, 10, ifp);
+  if (strncmp(buf, "LEICA", 5))
+  {
+    fseek(ifp, -10, SEEK_CUR);
+    if (uptag == 0x3400)
+      LeicaMakernoteSignature = 0x3400;
+    else
+      LeicaMakernoteSignature = -2; // DMR
+  }
+  else
+  {
+    fseek(ifp, -2, SEEK_CUR);
+    LeicaMakernoteSignature = ((uchar)buf[6] << 8) | (uchar)buf[7];
+    if (!LeicaMakernoteSignature &&
+        (!strncmp(model, "M8", 2) || !strncmp(model + 6, "M8", 2)))
+      LeicaMakernoteSignature = -3;
+    if ((LeicaMakernoteSignature != 0x0000) &&
+        (LeicaMakernoteSignature != 0x0200) &&
+        (LeicaMakernoteSignature != 0x0800) &&
+        (LeicaMakernoteSignature != 0x0900) &&
+        (LeicaMakernoteSignature != 0x02ff))
+      base = ftell(ifp) - 8;
+  }
+  setLeicaBodyFeatures(LeicaMakernoteSignature);
+
+  entries = get2();
+  if (entries > 1000)
+    return;
+  morder = order;
+
+  while (entries--)
+  {
+    order = morder;
+    tiff_get(base, &tag, &type, &len, &save);
+
+    INT64 pos = ifp->tell();
+    if (len > 8 && pos + len > 2 * fsize)
+    {
+      fseek(ifp, save, SEEK_SET); // Recover tiff-read position!!
+      continue;
+    }
+    tag |= uptag << 16;
+    if (len > 100 * 1024 * 1024)
+      goto next; // 100Mb tag? No!
+
+    if (LeicaMakernoteSignature == -3)
+    { // M8
+      if (tag == 0x0310)
+      {
+        parseLeicaLensID();
+      }
+      else if ((tag == 0x0313) && (fabs(ilm.CurAp) < 0.17f))
+      {
+        ilm.CurAp = getreal(type);
+        if (ilm.CurAp > 126.3)
+        {
+          ilm.CurAp = 0.0f;
+        }
+      }
+      else if (tag == 0x0320)
+      {
+        imCommon.CameraTemperature = getreal(type);
+      }
+    }
+    else if (LeicaMakernoteSignature == -2)
+    { // DMR
+      if (tag == 0x000d)
+      {
+        FORC3 cam_mul[c] = get2();
+        cam_mul[3] = cam_mul[1];
+      }
+    }
+    else if (LeicaMakernoteSignature == 0)
+    { // DIGILUX 2
+      if (tag == 0x0007)
+      {
+        imgdata.shootinginfo.FocusMode = get2();
+      }
+      else if (tag == 0x001a)
+      {
+        imgdata.shootinginfo.ImageStabilization = get2();
+      }
+    }
+    else if ((LeicaMakernoteSignature == 0x0100) || // X1
+             (LeicaMakernoteSignature == 0x0400) || // X VARIO
+             (LeicaMakernoteSignature == 0x0500) || // X2, X-E (Typ 102)
+             (LeicaMakernoteSignature == 0x0700) || // X (Typ 113)
+             (LeicaMakernoteSignature == 0x1000))
+    { // X-U (Typ 113)
+      if (tag == 0x040d)
+      {
+        ci = fgetc(ifp);
+        cj = fgetc(ifp);
+        imgdata.shootinginfo.ExposureMode = ((ushort)ci << 8) | cj;
+      }
+    }
+    else if ((LeicaMakernoteSignature == 0x0600) || // TL, T (Typ 701)
+             (LeicaMakernoteSignature == 0x1a00))
+    { // TL2
+      if (tag == 0x040d)
+      {
+        ci = fgetc(ifp);
+        cj = fgetc(ifp);
+        imgdata.shootinginfo.ExposureMode = ((ushort)ci << 8) | cj;
+      }
+      else if (tag == 0x0303)
+      {
+        parseLeicaLensName(len);
+      }
+    }
+    else if (LeicaMakernoteSignature == 0x0200)
+    { // M10, M10-D, S (Typ 007)
+    }
+    else if (LeicaMakernoteSignature == 0x02ff)
+    { // M (Typ 240), M (Typ 262), M-D (Typ 262), M Monochrom (Typ 246),
+      // S (Typ 006), S-E (Typ 006), S2, S3
+      if (tag == 0x0303)
+      {
+        if (parseLeicaLensName(len))
+        {
+          ilm.LensMount = ilm.CameraMount;
+          ilm.LensFormat = ilm.CameraFormat;
+        }
+      }
+    }
+    else if (LeicaMakernoteSignature == 0x0300)
+    { // M9, M9 Monochrom, M Monochrom, M-E
+      if (tag == 0x3400)
+      {
+        parseLeicaMakernote(base, 0x3400, MakernoteTagType);
+      }
+    }
+    else if ((LeicaMakernoteSignature == 0x0800) || // Q (Typ 116)
+             (LeicaMakernoteSignature == 0x0900))
+    { // SL (Typ 601), CL
+      if ((tag == 0x0304) && (len == 1) && ((c = fgetc(ifp)) != 0) &&
+          (ilm.CameraMount == LIBRAW_MOUNT_LPS_L))
+      {
+        strcpy(ilm.Adapter, "M-Adapter L");
+        ilm.LensMount = LIBRAW_MOUNT_Leica_M;
+        ilm.LensFormat = LIBRAW_FORMAT_FF;
+        ilm.LensID = c * 256;
+      }
+      else if (tag == 0x0500)
+      {
+        parseLeicaInternalBodySerial(len);
+      }
+    }
+    else if (LeicaMakernoteSignature == 0x3400)
+    { // tag 0x3400 in M9, M9 Monochrom, M Monochrom
+      if (tag == 0x34003402)
+      {
+        imCommon.CameraTemperature = getreal(type);
+      }
+      else if (tag == 0x34003405)
+      {
+        parseLeicaLensID();
+      }
+      else if ((tag == 0x34003406) && (fabs(ilm.CurAp) < 0.17f))
+      {
+        ilm.CurAp = getreal(type);
+        if (ilm.CurAp > 126.3)
+        {
+          ilm.CurAp = 0.0f;
+        }
+      }
+    }
+
+  next:
+    fseek(ifp, save, SEEK_SET);
+  }
+  order = sorder;
+}
